diff --git a/main.asm b/main.asm
index 0d81c646..b3e2074b 100755
--- a/main.asm
+++ b/main.asm
@@ -86789,11 +88678,16 @@ Func_5656d: ; 5656d (15:656d)
 	set 0, [hl]
 	ret
 
-Unknown_56577: ; 56577 (15:6577)
-INCBIN "baserom.gbc",$56577,$5657d - $56577
+SilphCo8ScriptPointers: ; 56577 (15:6577)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-SilphCo8Texts: ; 5657d (15:657d)
-	dw SilphCo8Text1, SilphCo8Text2, SilphCo8Text3, SilphCo8Text4
+SilphCo8TextPointers: ; 5657d (15:657d)
+	dw SilphCo8Text1
+	dw SilphCo8Text2
+	dw SilphCo8Text3
+	dw SilphCo8Text4
 
 SilphCo8TrainerHeaders: ; 56585 (15:6585)
 SilphCo8TrainerHeader0: ; 56585 (15:6585)
@@ -86823,7 +88717,7 @@ SilphCo8TrainerHeader2: ; 5659d (15:659d)
 	dw SilphCo8EndBattleText3 ; 0x6609 TextEndBattle
 	dw SilphCo8EndBattleText3 ; 0x6609 TextEndBattle
 
-db $ff
+	db $ff
 
 SilphCo8Text1: ; 565aa (15:65aa)
 	db $08 ; asm
@@ -87393,7 +89287,7 @@ SECTION "bank16",ROMX,BANK[$16]
 Route6_h: ; 0x58000 to 0x58022 (34 bytes) (id=17)
 	db $00 ; tileset
 	db ROUTE_6_HEIGHT, ROUTE_6_WIDTH ; dimensions (y, x)
-	dw Route6Blocks, Route6Texts, Route6Script ; blocks, texts, scripts
+	dw Route6Blocks, Route6TextPointers, Route6Script ; blocks, texts, scripts
 	db NORTH | SOUTH ; connections
 
 	; connections data
@@ -87448,7 +89342,7 @@ Route6Blocks: ; 58079 (16:4079)
 Route8_h: ; 0x5812d to 0x5814f (34 bytes) (id=19)
 	db $00 ; tileset
 	db ROUTE_8_HEIGHT, ROUTE_8_WIDTH ; dimensions (y, x)
-	dw Route8Blocks, Route8Texts, Route8Script ; blocks, texts, scripts
+	dw Route8Blocks, Route8TextPointers, Route8Script ; blocks, texts, scripts
 	db WEST | EAST ; connections
 
 	; connections data
@@ -87508,7 +89402,7 @@ Route8Blocks: ; 581c6 (16:41c6)
 Route10_h: ; 0x582d4 to 0x582f6 (34 bytes) (id=21)
 	db $00 ; tileset
 	db ROUTE_10_HEIGHT, ROUTE_10_WIDTH ; dimensions (y, x)
-	dw Route10Blocks, Route10Texts, Route10Script ; blocks, texts, scripts
+	dw Route10Blocks, Route10TextPointers, Route10Script ; blocks, texts, scripts
 	db SOUTH | WEST ; connections
 
 	; connections data
@@ -87566,7 +89460,7 @@ Route10Blocks: ; 58356 (16:4356)
 Route11_h: ; 0x584be to 0x584e0 (34 bytes) (id=22)
 	db $00 ; tileset
 	db ROUTE_11_HEIGHT, ROUTE_11_WIDTH ; dimensions (y, x)
-	dw Route11Blocks, Route11Texts, Route11Script ; blocks, texts, scripts
+	dw Route11Blocks, Route11TextPointers, Route11Script ; blocks, texts, scripts
 	db WEST | EAST ; connections
 
 	; connections data
@@ -87627,7 +89521,7 @@ Route11Blocks: ; 5855f (16:455f)
 Route12_h: ; 0x5866d to 0x5869a (45 bytes) (id=23)
 	db $00 ; tileset
 	db ROUTE_12_HEIGHT, ROUTE_12_WIDTH ; dimensions (y, x)
-	dw Route12Blocks, Route12Texts, Route12Script ; blocks, texts, scripts
+	dw Route12Blocks, Route12TextPointers, Route12Script ; blocks, texts, scripts
 	db NORTH | SOUTH | WEST ; connections
 
 	; connections data
@@ -87694,7 +89588,7 @@ Route12Blocks: ; 58710 (16:4710)
 Route15_h: ; 0x5892c to 0x5894e (34 bytes) (id=26)
 	db $00 ; tileset
 	db ROUTE_15_HEIGHT, ROUTE_15_WIDTH ; dimensions (y, x)
-	dw Route15Blocks, Route15Texts, Route15Script ; blocks, texts, scripts
+	dw Route15Blocks, Route15TextPointers, Route15Script ; blocks, texts, scripts
 	db WEST | EAST ; connections
 
 	; connections data
@@ -87754,7 +89648,7 @@ Route15Blocks: ; 589cc (16:49cc)
 Route16_h: ; 0x58ada to 0x58afc (34 bytes) (id=27)
 	db $00 ; tileset
 	db ROUTE_16_HEIGHT, ROUTE_16_WIDTH ; dimensions (y, x)
-	dw Route16Blocks, Route16Texts, Route16Script ; blocks, texts, scripts
+	dw Route16Blocks, Route16TextPointers, Route16Script ; blocks, texts, scripts
 	db SOUTH | EAST ; connections
 
 	; connections data
@@ -87821,7 +89715,7 @@ Route16Blocks: ; 58b84 (16:4b84)
 Route18_h: ; 0x58c38 to 0x58c5a (34 bytes) (id=29)
 	db $00 ; tileset
 	db ROUTE_18_HEIGHT, ROUTE_18_WIDTH ; dimensions (y, x)
-	dw Route18Blocks, Route18Texts, Route18Script ; blocks, texts, scripts
+	dw Route18Blocks, Route18TextPointers, Route18Script ; blocks, texts, scripts
 	db NORTH | EAST ; connections
 
 	; connections data
@@ -88203,12 +90097,12 @@ CalcDSquared: ; 59010 (16:5010)
 ;  (a*n^3)/b + sign*c*n^2 + d*n - e
 ; where sign = -1 <=> S=1
 GrowthRateTable: ; 5901d (16:501d)
-db $11,$00,$00,$00 ; medium fast      n^3
-db $34,$0A,$00,$1E ; (unused?)    3/4 n^3 + 10 n^2         - 30
-db $34,$14,$00,$46 ; (unused?)    3/4 n^3 + 20 n^2         - 70
-db $65,$8F,$64,$8C ; medium slow: 6/5 n^3 - 15 n^2 + 100 n - 140
-db $45,$00,$00,$00 ; fast:        4/5 n^3
-db $54,$00,$00,$00 ; slow:        5/4 n^3
+	db $11,$00,$00,$00 ; medium fast      n^3
+	db $34,$0A,$00,$1E ; (unused?)    3/4 n^3 + 10 n^2         - 30
+	db $34,$14,$00,$46 ; (unused?)    3/4 n^3 + 20 n^2         - 70
+	db $65,$8F,$64,$8C ; medium slow: 6/5 n^3 - 15 n^2 + 100 n - 140
+	db $45,$00,$00,$00 ; fast:        4/5 n^3
+	db $54,$00,$00,$00 ; slow:        5/4 n^3
 
 Func_59035 ; 0x59035
 	ld hl, UnnamedText_59091 ; $5091
@@ -88283,17 +90177,25 @@ UnnamedText_590ab: ; 590ab (16:50ab)
 Route6Script: ; 590b0 (16:50b0)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route6TrainerHeaders
-	ld de, Route6_Unknown590c3
+	ld de, Route6ScriptPointers
 	ld a, [W_ROUTE6CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE6CURSCRIPT], a
 	ret
 
-Route6_Unknown590c3: ; 590c3 (16:50c3)
-INCBIN "baserom.gbc",$590c3,$590c9 - $590c3
+Route6ScriptPointers: ; 590c3 (16:50c3)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route6Texts: ; 590c9 (16:50c9)
-	dw Route6Text1, Route6Text2, Route6Text3, Route6Text4, Route6Text5, Route6Text6, Route6Text7
+Route6TextPointers: ; 590c9 (16:50c9)
+	dw Route6Text1
+	dw Route6Text2
+	dw Route6Text3
+	dw Route6Text4
+	dw Route6Text5
+	dw Route6Text6
+	dw Route6Text7
 
 Route6TrainerHeaders: ; 590d7 (16:50d7)
 Route6TrainerHeader0: ; 590d7 (16:50d7)
@@ -88350,7 +90252,7 @@ Route6TrainerHeader5: ; 59113 (16:5113)
 	dw Route6EndBattleText6 ; 0x51a7 TextEndBattle
 	dw Route6EndBattleText6 ; 0x51a7 TextEndBattle
 
-db $ff
+	db $ff
 
 Route6Text1: ; 59120 (16:5120)
 	db $8
@@ -88463,17 +90365,28 @@ Route6Text7: ; 591b1 (16:51b1)
 Route8Script: ; 591b6 (16:51b6)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route8TrainerHeaders
-	ld de, Route8_Unknown591c9
+	ld de, Route8ScriptPointers
 	ld a, [W_ROUTE8CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE8CURSCRIPT], a
 	ret
 
-Route8_Unknown591c9: ; 591c9 (16:51c9)
-INCBIN "baserom.gbc",$591c9,$591cf - $591c9
+Route8ScriptPointers: ; 591c9 (16:51c9)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route8Texts: ; 591cf (16:51cf)
-	dw Route8Text1, Route8Text2, Route8Text3, Route8Text4, Route8Text5, Route8Text6, Route8Text7, Route8Text8, Route8Text9, Route8Text10
+Route8TextPointers: ; 591cf (16:51cf)
+	dw Route8Text1
+	dw Route8Text2
+	dw Route8Text3
+	dw Route8Text4
+	dw Route8Text5
+	dw Route8Text6
+	dw Route8Text7
+	dw Route8Text8
+	dw Route8Text9
+	dw Route8Text10
 
 Route8TrainerHeaders: ; 591e3 (16:51e3)
 Route8TrainerHeader0: ; 591e3 (16:51e3)
@@ -88557,7 +90470,7 @@ Route8TrainerHeader8: ; 59243 (16:5243)
 	dw Route8EndBattleText9 ; 0x5327 TextEndBattle
 	dw Route8EndBattleText9 ; 0x5327 TextEndBattle
 
-db $ff
+	db $ff
 
 Route8Text1: ; 59250 (16:5250)
 	db $8
@@ -88728,17 +90641,28 @@ Route8Text10: ; 59331 (16:5331)
 Route10Script: ; 59336 (16:5336)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route10TrainerHeaders
-	ld de, Route10_Unknown59349
+	ld de, Route10ScriptPointers
 	ld a, [W_ROUTE10CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE10CURSCRIPT], a
 	ret
 
-Route10_Unknown59349: ; 59349 (16:5349)
-INCBIN "baserom.gbc",$59349,$5934f - $59349
+Route10ScriptPointers: ; 59349 (16:5349)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route10Texts: ; 5934f (16:534f)
-	dw Route10Text1, Route10Text2, Route10Text3, Route10Text4, Route10Text5, Route10Text6, Route10Text7, PokeCenterSignText, Route10Text9, Route10Text10
+Route10TextPointers: ; 5934f (16:534f)
+	dw Route10Text1
+	dw Route10Text2
+	dw Route10Text3
+	dw Route10Text4
+	dw Route10Text5
+	dw Route10Text6
+	dw Route10Text7
+	dw PokeCenterSignText
+	dw Route10Text9
+	dw Route10Text10
 
 Route10TrainerHeaders: ; 59363 (16:5363)
 Route10TrainerHeader0: ; 59363 (16:5363)
@@ -88795,7 +90719,7 @@ Route10TrainerHeader5: ; 5939f (16:539f)
 	dw Route10EndBattleText6 ; 0x5438 TextEndBattle
 	dw Route10EndBattleText6 ; 0x5438 TextEndBattle
 
-db $ff
+	db $ff
 
 Route10Text1: ; 593ac (16:53ac)
 	db $08 ; asm
@@ -88917,19 +90841,29 @@ Route10Text10: ; 59447 (16:5447)
 Route11Script: ; 5944c (16:544c)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route11TrainerHeaders
-	ld de, Route11_Unknown5945f
+	ld de, Route11ScriptPointers
 	ld a, [W_ROUTE11CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE11CURSCRIPT], a
 	ret
 
-Route11_Unknown5945f: ; 5945f (16:545f)
+Route11ScriptPointers: ; 5945f (16:545f)
 	dw CheckFightingMapTrainers
 	dw Func_324c
 	dw EndTrainerBattle
 
-Route11Texts: ; 59465 (16:5465)
-	dw UnnamedText_594f4, Route11Text2, Route11Text3, Route11Text4, Route11Text5, Route11Text6, Route11Text7, Route11Text8, Route11Text9, Route11Text10, Route11Text11
+Route11TextPointers: ; 59465 (16:5465)
+	dw Route11Text1
+	dw Route11Text2
+	dw Route11Text3
+	dw Route11Text4
+	dw Route11Text5
+	dw Route11Text6
+	dw Route11Text7
+	dw Route11Text8
+	dw Route11Text9
+	dw Route11Text10
+	dw Route11Text11
 
 Route11TrainerHeaders: ; 5947b (16:547b)
 Route11TrainerHeader0: ; 5947b (16:547b)
@@ -89022,9 +90956,9 @@ Route11TrainerHeader9: ; 594e7 (16:54e7)
 	dw Route11EndBattleText10 ; 0x55e4 TextEndBattle
 	dw Route11EndBattleText10 ; 0x55e4 TextEndBattle
 
-db $ff
+	db $ff
 
-UnnamedText_594f4: ; 594f4 (16:54f4)
+Route11Text1: ; 594f4 (16:54f4)
 	db $8
 	ld hl, Route11TrainerHeader0
 	call TalkToTrainer
@@ -89211,21 +91145,26 @@ Route11Text11: ; 595ee (16:55ee)
 Route12Script: ; 595f3 (16:55f3)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route12TrainerHeaders
-	ld de, .unknown_59611 ; $5611
+	ld de, Route12ScriptPointers
 	ld a, [W_ROUTE12CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE12CURSCRIPT], a
 	ret
-.asm_59606
+
+Route12Script_59606: ; 59606 (16:5606)
 	xor a
 	ld [wJoypadForbiddenButtonsMask], a
 	ld [W_ROUTE12CURSCRIPT], a
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-.unknown_59611: ; 59611 (16:5611)
-INCBIN "baserom.gbc",$59611,$59619 - $59611
+Route12ScriptPointers: ; 59611 (16:5611)
+	dw Route12Script0
+	dw Func_324c
+	dw EndTrainerBattle
+	dw Route12Script3
 
+Route12Script0: ; 59619 (16:5619)
 	ld hl, $d7d8
 	bit 7, [hl]
 	jp nz, CheckFightingMapTrainers
@@ -89247,9 +91186,11 @@ INCBIN "baserom.gbc",$59611,$59619 - $59611
 	ld [W_ROUTE12CURSCRIPT], a
 	ld [W_CURMAPSCRIPT], a
 	ret
+
+Route12Script3: ; 5964c (16:564c)
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
-	jr z, .asm_59606
+	jr z, Route12Script_59606
 	call UpdateSprites
 	ld a, [$cf0b]
 	cp $2
@@ -89266,8 +91207,21 @@ INCBIN "baserom.gbc",$59611,$59619 - $59611
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Route12Texts: ; 59675 (16:5675)
-	dw Route12Text1, Route12Text2, Route12Text3, Route12Text4, Route12Text5, Route12Text6, Route12Text7, Route12Text8, Predef5CText, Predef5CText, Route12Text11, Route12Text12, Route12Text13, Route12Text14
+Route12TextPointers: ; 59675 (16:5675)
+	dw Route12Text1
+	dw Route12Text2
+	dw Route12Text3
+	dw Route12Text4
+	dw Route12Text5
+	dw Route12Text6
+	dw Route12Text7
+	dw Route12Text8
+	dw Predef5CText
+	dw Predef5CText
+	dw Route12Text11
+	dw Route12Text12
+	dw Route12Text13
+	dw Route12Text14
 
 Route12TrainerHeaders: ; 59691 (16:5691)
 Route12TrainerHeader0: ; 59691 (16:5691)
@@ -89333,7 +91287,7 @@ Route12TrainerHeader6: ; 596d9 (16:56d9)
 	dw Route12EndBattleText7 ; 0x579a TextEndBattle
 	dw Route12EndBattleText7 ; 0x579a TextEndBattle
 
-db $ff
+	db $ff
 
 Route12Text1: ; 596e6 (16:56e6)
 	TX_FAR _Route12Text1
@@ -89486,17 +91440,30 @@ Route12Text12: ; 597a9 (16:57a9)
 Route15Script: ; 597ae (16:57ae)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route15TrainerHeaders
-	ld de, Route15_Unknown597c1
+	ld de, Route15ScriptPointers
 	ld a, [W_ROUTE15CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE15CURSCRIPT], a
 	ret
 
-Route15_Unknown597c1: ; 597c1 (16:57c1)
-INCBIN "baserom.gbc",$597c1,$597c7 - $597c1
+Route15ScriptPointers: ; 597c1 (16:57c1)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route15Texts: ; 597c7 (16:57c7)
-	dw Route15Text1, Route15Text2, Route15Text3, Route15Text4, Route15Text5, Route15Text6, Route15Text7, Route15Text8, Route15Text9, Route15Text10, Predef5CText, Route15Text12
+Route15TextPointers: ; 597c7 (16:57c7)
+	dw Route15Text1
+	dw Route15Text2
+	dw Route15Text3
+	dw Route15Text4
+	dw Route15Text5
+	dw Route15Text6
+	dw Route15Text7
+	dw Route15Text8
+	dw Route15Text9
+	dw Route15Text10
+	dw Predef5CText
+	dw Route15Text12
 
 Route15TrainerHeaders: ; 597df (16:57df)
 Route15TrainerHeader0: ; 597df (16:57df)
@@ -89589,7 +91556,7 @@ Route15TrainerHeader9: ; 5984b (16:584b)
 	dw Route15EndBattleText10 ; 0x5924 TextEndBattle
 	dw Route15EndBattleText10 ; 0x5924 TextEndBattle
 
-db $ff
+	db $ff
 
 Route15Text1: ; 59858 (16:5858)
 	db $8 ; asm
@@ -89770,7 +91737,7 @@ Route15Text12: ; 5992e (16:592e)
 Route16Script: ; 59933 (16:5933)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route16TrainerHeaders
-	ld de, Unknown_59951 ; $5951
+	ld de, Route16ScriptPointers
 	ld a, [W_ROUTE16CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE16CURSCRIPT], a
@@ -89783,8 +91750,13 @@ Func_59946: ; 59946 (16:5946)
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Unknown_59951: ; 59951 (16:5951)
-INCBIN "baserom.gbc",$59951,$59959 - $59951
+Route16ScriptPointers: ; 59951 (16:5951)
+	dw Route16Script0
+	dw Func_324c
+	dw EndTrainerBattle
+	dw Route16Script3
+
+Route16Script0: ; 59959 (16:5959)
 	ld hl, $d7e0
 	bit 1, [hl]
 	jp nz, CheckFightingMapTrainers
@@ -89807,6 +91779,8 @@ INCBIN "baserom.gbc",$59951,$59959 - $59951
 	ld [W_ROUTE16CURSCRIPT], a
 	ld [W_CURMAPSCRIPT], a
 	ret
+
+Route16Script3: ; 5998f (16:598f)
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
 	jp z, Func_59946
@@ -89826,8 +91800,18 @@ INCBIN "baserom.gbc",$59951,$59959 - $59951
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Route16Texts: ; 599b9 (16:59b9)
-	dw Route16Text1, Route16Text2, Route16Text3, Route16Text4, Route16Text5, Route16Text6, Route16Text7, Route16Text8, Route16Text9, Route16Text10, Route16Text11
+Route16TextPointers: ; 599b9 (16:59b9)
+	dw Route16Text1
+	dw Route16Text2
+	dw Route16Text3
+	dw Route16Text4
+	dw Route16Text5
+	dw Route16Text6
+	dw Route16Text7
+	dw Route16Text8
+	dw Route16Text9
+	dw Route16Text10
+	dw Route16Text11
 
 Route16TrainerHeaders: ; 599cf (16:59cf)
 Route16TrainerHeader0: ; 599cf (16:59cf)
@@ -89884,7 +91868,7 @@ Route16TrainerHeader5: ; 59a0b (16:5a0b)
 	dw Route16EndBattleText6 ; 0x5aa4 TextEndBattle
 	dw Route16EndBattleText6 ; 0x5aa4 TextEndBattle
 
-db $ff
+	db $ff
 
 Route16Text1: ; 59a18 (16:5a18)
 	db $08 ; asm
@@ -90017,17 +92001,23 @@ Route16Text9: ; 59ac2 (16:5ac2)
 Route18Script: ; 59ac7 (16:5ac7)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route18TrainerHeaders
-	ld de, Route18_Unknown59ada
+	ld de, Route18ScriptPointers
 	ld a, [W_ROUTE18CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE18CURSCRIPT], a
 	ret
 
-Route18_Unknown59ada: ; 59ada (16:5ada)
-INCBIN "baserom.gbc",$59ada,$59ae0 - $59ada
+Route18ScriptPointers: ; 59ada (16:5ada)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route18Texts: ; 59ae0 (16:5ae0)
-	dw Route18Text1, Route18Text2, Route18Text3, Route18Text4, Route18Text5
+Route18TextPointers: ; 59ae0 (16:5ae0)
+	dw Route18Text1
+	dw Route18Text2
+	dw Route18Text3
+	dw Route18Text4
+	dw Route18Text5
 
 Route18TrainerHeaders: ; 59aea (16:5aea)
 Route18TrainerHeader0: ; 59aea (16:5aea)
@@ -90057,7 +92047,7 @@ Route18TrainerHeader2: ; 59b02 (16:5b02)
 	dw Route18EndBattleText3 ; 0x5b50 TextEndBattle
 	dw Route18EndBattleText3 ; 0x5b50 TextEndBattle
 
-db $ff
+	db $ff
 
 Route18Text1: ; 59b0f (16:5b0f)
 	db $08 ; asm
@@ -90124,7 +92114,7 @@ Route18Text5: ; 59b5f (16:5b5f)
 FanClub_h: ; 0x59b64 to 0x59b70 (12 bytes) (id=90)
 	db $10 ; tileset
 	db POKEMON_FAN_CLUB_HEIGHT, POKEMON_FAN_CLUB_WIDTH ; dimensions (y, x)
-	dw FanClubBlocks, FanClubTexts, FanClubScript ; blocks, texts, scripts
+	dw FanClubBlocks, FanClubTextPointers, FanClubScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw FanClubObject ; objects
@@ -90142,8 +92132,15 @@ Func_59b73: ; 59b73 (16:5b73)
 	ld b, $2d
 	jp IsItemInBag
 
-FanClubTexts: ; 59b84 (16:5b84)
-	dw FanClubText1, FanClubText2, FanClubText3, FanClubText4, FanClubText5, FanClubText6, FanClubText7, FanClubText8
+FanClubTextPointers: ; 59b84 (16:5b84)
+	dw FanClubText1
+	dw FanClubText2
+	dw FanClubText3
+	dw FanClubText4
+	dw FanClubText5
+	dw FanClubText6
+	dw FanClubText7
+	dw FanClubText8
 
 FanClubText1: ; 59b94 (16:5b94)
 	db $08 ; asm
@@ -90324,23 +92321,50 @@ FanClubBlocks: ; 59cd5 (16:5cd5)
 SilphCo2_h: ; 0x59ce5 to 0x59cf1 (12 bytes) (id=207)
 	db $16 ; tileset
 	db SILPH_CO_2F_HEIGHT, SILPH_CO_2F_WIDTH ; dimensions (y, x)
-	dw SilphCo2Blocks, SilphCo2Texts, SilphCo2Script ; blocks, texts, scripts
+	dw SilphCo2Blocks, SilphCo2TextPointers, SilphCo2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SilphCo2Object ; objects
 
 SilphCo2Script: ; 59cf1 (16:5cf1)
-	call SilphCo2_Unknown59d07
+	call SilphCo2Script_59d07
 	call EnableAutoTextBoxDrawing
 	ld hl, SilphCo2TrainerHeaders
-	ld de, Unknown_59d80 ; $5d80
+	ld de, SilphCo2ScriptPointers
 	ld a, [W_SILPHCO2CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_SILPHCO2CURSCRIPT], a
 	ret
 
-SilphCo2_Unknown59d07: ; 59d07 (16:5d07)
-INCBIN "baserom.gbc",$59d07,$59d43 - $59d07
+SilphCo2Script_59d07: ; 59d07 (16:5d07)
+	ld hl, $d126
+	bit 5, [hl]
+	res 5, [hl]
+	ret z
+	ld hl, Unknown_59d3e
+	call Func_59d43
+	call Func_59d6f
+	ld a, [$d826]
+	bit 5, a
+	jr nz, .asm_59d2e
+	push af
+	ld a, $54
+	ld [$d09f], a
+	ld bc, $0202
+	ld a, $17
+	call Predef
+	pop af
+.asm_59d2e
+	bit 6, a
+	ret nz
+	ld a, $54
+	ld [$d09f], a
+	ld bc, $0502
+	ld a, $17
+	jp Predef
+
+Unknown_59d3e: ; 59d3e (16:5d3e)
+INCBIN "baserom.gbc",$59d3e,$59d43 - $59d3e
 
 Func_59d43: ; 59d43 (16:5d43)
 	push hl
@@ -90378,13 +92402,30 @@ Func_59d43: ; 59d43 (16:5d43)
 	ld [$FF00+$e0], a
 	ret
 
-INCBIN "baserom.gbc",$59d6f,$59d80 - $59d6f
+Func_59d6f: ; 59d6f (16:5d6f)
+	ld hl, $d826
+	ld a, [$ffe0]
+	and a
+	ret z
+	cp $1
+	jr nz, .asm_59d7d
+	set 5, [hl]
+	ret
+.asm_59d7d
+	set 6, [hl]
+	ret
 
-Unknown_59d80: ; 59d80 (16:5d80)
-INCBIN "baserom.gbc",$59d80,$59d86 - $59d80
+SilphCo2ScriptPointers: ; 59d80 (16:5d80)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-SilphCo2Texts: ; 59d86 (16:5d86)
-	dw SilphCo2Text1, SilphCo2Text2, SilphCo2Text3, SilphCo2Text4, SilphCo2Text5
+SilphCo2TextPointers: ; 59d86 (16:5d86)
+	dw SilphCo2Text1
+	dw SilphCo2Text2
+	dw SilphCo2Text3
+	dw SilphCo2Text4
+	dw SilphCo2Text5
 
 SilphCo2TrainerHeaders: ; 59d90 (16:5d90)
 SilphCo2TrainerHeader0: ; 59d90 (16:5d90)
@@ -90423,7 +92464,7 @@ SilphCo2TrainerHeader3: ; 59db4 (16:5db4)
 	dw SilphCo2EndBattleText4 ; 0x5e5c TextEndBattle
 	dw SilphCo2EndBattleText4 ; 0x5e5c TextEndBattle
 
-db $ff
+	db $ff
 
 SilphCo2Text1: ; 59dc1 (16:5dc1)
 	db $08 ; asm
@@ -90570,22 +92611,22 @@ SilphCo2Blocks: ; 59ec8 (16:5ec8)
 SilphCo3_h: ; 0x59f4f to 0x59f5b (12 bytes) (id=208)
 	db $16 ; tileset
 	db SILPH_CO_3F_HEIGHT, SILPH_CO_3F_WIDTH ; dimensions (y, x)
-	dw SilphCo3Blocks, SilphCo3Texts, SilphCo3Script ; blocks, texts, scripts
+	dw SilphCo3Blocks, SilphCo3TextPointers, SilphCo3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SilphCo3Object ; objects
 
 SilphCo3Script: ; 59f5b (16:5f5b)
-	call SilphCo3Script_Unknown59f71
+	call SilphCo3Script_59f71
 	call EnableAutoTextBoxDrawing
 	ld hl, SilphCo3TrainerHeaders
-	ld de, Unknown_59fbe ; $5fbe
+	ld de, SilphCo3ScriptPointers
 	ld a, [W_SILPHCO3CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_SILPHCO3CURSCRIPT], a
 	ret
 
-SilphCo3Script_Unknown59f71: ; 59f71 (16:5f71)
+SilphCo3Script_59f71: ; 59f71 (16:5f71)
 	ld hl, $d126
 	bit 5, [hl]
 	res 5, [hl]
@@ -90628,11 +92669,16 @@ Func_59fad: ; 59fad (16:5fad)
 	set 1, [hl]
 	ret
 
-Unknown_59fbe: ; 59fbe (16:5fbe)
-INCBIN "baserom.gbc",$59fbe,$59fc4 - $59fbe
+SilphCo3ScriptPointers: ; 59fbe (16:5fbe)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-SilphCo3Texts: ; 59fc4 (16:5fc4)
-	dw SilphCo3Text1, SilphCo3Text2, SilphCo3Text3, Predef5CText
+SilphCo3TextPointers: ; 59fc4 (16:5fc4)
+	dw SilphCo3Text1
+	dw SilphCo3Text2
+	dw SilphCo3Text3
+	dw Predef5CText
 
 SilphCo3TrainerHeaders: ; 59fcc (16:5fcc)
 SilphCo3TrainerHeader0: ; 59fcc (16:5fcc)
@@ -90653,7 +92699,7 @@ SilphCo3TrainerHeader1: ; 59fd8 (16:5fd8)
 	dw SilphCo3EndBattleText2 ; 0x602b TextEndBattle
 	dw SilphCo3EndBattleText2 ; 0x602b TextEndBattle
 
-db $ff
+	db $ff
 
 SilphCo3Text1: ; 59fe5 (16:5fe5)
 	db $08 ; asm
@@ -90751,22 +92797,22 @@ SilphCo3Blocks: ; 5a0a6 (16:60a6)
 SilphCo10_h: ; 0x5a12d to 0x5a139 (12 bytes) (id=234)
 	db $16 ; tileset
 	db SILPH_CO_10F_HEIGHT, SILPH_CO_10F_WIDTH ; dimensions (y, x)
-	dw SilphCo10Blocks, SilphCo10Texts, SilphCo10Script ; blocks, texts, scripts
+	dw SilphCo10Blocks, SilphCo10TextPointers, SilphCo10Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SilphCo10Object ; objects
 
 SilphCo10Script: ; 5a139 (16:6139)
-	call SilphCo10Script_Unknown5a14f
+	call SilphCo10Script_5a14f
 	call EnableAutoTextBoxDrawing
 	ld hl, SilphCo10TrainerHeaders
-	ld de, Unknown_5a180 ; $6180
+	ld de, SilphCo10ScriptPointers
 	ld a, [W_SILPHCO10CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_SILPHCO10CURSCRIPT], a
 	ret
 
-SilphCo10Script_Unknown5a14f: ; 5a14f (16:614f)
+SilphCo10Script_5a14f: ; 5a14f (16:614f)
 	ld hl, $d126
 	bit 5, [hl]
 	res 5, [hl]
@@ -90794,11 +92840,18 @@ Func_5a176: ; 5a176 (16:6176)
 	set 0, [hl]
 	ret
 
-Unknown_5a180: ; 5a180 (16:6180)
-INCBIN "baserom.gbc",$5a180,$5a186 - $5a180
+SilphCo10ScriptPointers: ; 5a180 (16:6180)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-SilphCo10Texts: ; 5a186 (16:6186)
-	dw SilphCo10Text1, SilphCo10Text2, SilphCo10Text3, Predef5CText, Predef5CText, Predef5CText
+SilphCo10TextPointers: ; 5a186 (16:6186)
+	dw SilphCo10Text1
+	dw SilphCo10Text2
+	dw SilphCo10Text3
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
 
 SilphCo10TrainerHeaders: ; 5a192 (16:6192)
 SilphCo10TrainerHeader0: ; 5a192 (16:6192)
@@ -90819,7 +92872,7 @@ SilphCo10TrainerHeader1: ; 5a19e (16:619e)
 	dw SilphCo10EndBattleText2 ; 0x61f1 TextEndBattle
 	dw SilphCo10EndBattleText2 ; 0x61f1 TextEndBattle
 
-db $ff
+	db $ff
 
 SilphCo10Text1: ; 5a1ab (16:61ab)
 	db $08 ; asm
@@ -90838,9 +92891,9 @@ SilphCo10Text3: ; 5a1bf (16:61bf)
 	ld a, [$d838]
 	bit 7, a
 	ld hl, UnnamedText_5a1d8
-	jr nz, asm_cf85f ; 0x5a1c8
+	jr nz, .asm_cf85f
 	ld hl, UnnamedText_5a1d3
-asm_cf85f ; 0x5a1cd
+.asm_cf85f
 	call PrintText
 	jp TextScriptEnd
 
@@ -90911,22 +92964,22 @@ SilphCo10Blocks: ; 5a25a (16:625a)
 Lance_h: ; 0x5a2a2 to 0x5a2ae (12 bytes) (id=113)
 	db $05 ; tileset
 	db LANCES_ROOM_HEIGHT, LANCES_ROOM_WIDTH ; dimensions (y, x)
-	dw LanceBlocks, LanceTexts, LanceScript ; blocks, texts, scripts
+	dw LanceBlocks, LanceTextPointers, LanceScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw LanceObject ; objects
 
 LanceScript: ; 5a2ae (16:62ae)
-	call LanceScript_Unknown5a2c4
+	call LanceScript_5a2c4
 	call EnableAutoTextBoxDrawing
 	ld hl, LanceTrainerHeaders
-	ld de, Unknown_5a2fa ; $62fa
+	ld de, LanceScriptPointers
 	ld a, [W_LANCECURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_LANCECURSCRIPT], a
 	ret
 
-LanceScript_Unknown5a2c4: ; 5a2c4 (16:62c4)
+LanceScript_5a2c4: ; 5a2c4 (16:62c4)
 	ld hl, $d126
 	bit 5, [hl]
 	res 5, [hl]
@@ -90960,12 +93013,21 @@ Func_5a2f5: ; 5a2f5 (16:62f5)
 	ld [W_LANCECURSCRIPT], a
 	ret
 
-Unknown_5a2fa: ; 5a2fa (16:62fa)
-INCBIN "baserom.gbc",$5a2fa,$5a305 - $5a2fa
+LanceScriptPointers: ; 5a2fa (16:62fa)
+	dw LanceScript0
+	dw Func_324c
+	dw LanceScript2
+	dw LanceScript3
+	dw LanceScript4
+
+LanceScript4: ; 5a304 (16:6304)
+	ret
+
+LanceScript0: ; 5a305 (16:6305)
 	ld a, [$d866]
 	bit 6, a
 	ret nz
-	ld hl, .unknown_5a33e ; $633e
+	ld hl, CoordsData_5a33e ; $633e
 	call ArePlayerCoordsInArray
 	jp nc, CheckFightingMapTrainers
 	xor a
@@ -90978,7 +93040,7 @@ INCBIN "baserom.gbc",$5a2fa,$5a305 - $5a2fa
 	jp DisplayTextID
 .asm_5a325
 	cp $5
-	jr z, .asm_5a35b
+	jr z, Func_5a35b
 	ld hl, $d866
 	bit 7, [hl]
 	set 7, [hl]
@@ -90987,11 +93049,12 @@ INCBIN "baserom.gbc",$5a2fa,$5a305 - $5a2fa
 	set 5, [hl]
 	ld a, $ad
 	call PlaySound
-	jp LanceScript_Unknown5a2c4
+	jp LanceScript_5a2c4
 
-.unknown_5a33e: ; 5a33e (16:633e)
+CoordsData_5a33e: ; 5a33e (16:633e)
 INCBIN "baserom.gbc",$5a33e,$5a349 - $5a33e
 
+LanceScript2: ; 5a349 (16:6349)
 	call EndTrainerBattle
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
@@ -90999,7 +93062,8 @@ INCBIN "baserom.gbc",$5a33e,$5a349 - $5a33e
 	ld a, $1
 	ld [H_DOWNARROWBLINKCNT2], a ; $FF00+$8c
 	jp DisplayTextID
-.asm_5a35b
+
+Func_5a35b: ; 5a35b (16:635b)
 	ld a, $ff
 	ld [wJoypadForbiddenButtonsMask], a
 	ld hl, $ccd3
@@ -91014,13 +93078,13 @@ INCBIN "baserom.gbc",$5a33e,$5a349 - $5a33e
 	ret
 
 RLEList_5a379: ; 5a379 (16:6379)
-db $40, $0C
-db $20, $0C
-db $80, $07
-db $20, $06
-db $FF
+	db $40, $0C
+	db $20, $0C
+	db $80, $07
+	db $20, $06
+	db $FF
 
-Func_5a382: ; 5a382 (16:6382)
+LanceScript3: ; 5a382 (16:6382)
 	ld a, [$cd38]
 	and a
 	ret nz
@@ -91031,7 +93095,7 @@ Func_5a382: ; 5a382 (16:6382)
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-LanceTexts: ; 5a395 (16:6395)
+LanceTextPointers: ; 5a395 (16:6395)
 	dw LanceText1
 
 LanceTrainerHeaders: ; 5a397 (16:6397)
@@ -91044,7 +93108,7 @@ LanceTrainerHeader0: ; 5a397 (16:6397)
 	dw LanceEndBattleText ; 0x63b3 TextEndBattle
 	dw LanceEndBattleText ; 0x63b3 TextEndBattle
 
-db $ff
+	db $ff
 
 LanceText1: ; 5a3a4 (16:63a4)
 	db $08 ; asm
@@ -91091,21 +93155,24 @@ LanceBlocks: ; 5a3e9 (16:63e9)
 HallofFameRoom_h: ; 0x5a492 to 0x5a49e (12 bytes) (id=118)
 	db $07 ; tileset
 	db HALL_OF_FAME_HEIGHT, HALL_OF_FAME_WIDTH ; dimensions (y, x)
-	dw HallofFameRoomBlocks, HallofFameRoomTexts, HallofFameRoomScript ; blocks, texts, scripts
+	dw HallofFameRoomBlocks, HallofFameRoomTextPointers, HallofFameRoomScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw HallofFameRoomObject ; objects
 
 HallofFameRoomScript: ; 5a49e (16:649e)
 	call EnableAutoTextBoxDrawing
-	ld hl, HallofFameRoomScripts
+	ld hl, HallofFameRoomScriptPointers
 	ld a, [W_HALLOFFAMEROOMCURSCRIPT]
 	jp CallFunctionInTable
 
 INCBIN "baserom.gbc",$5a4aa,$5a4b2 - $5a4aa
 
-HallofFameRoomScripts: ; 5a4b2 (16:64b2)
-	dw HallofFameRoomScript0, HallofFameRoomScript1, HallofFameRoomScript2, HallofFameRoomScript3
+HallofFameRoomScriptPointers: ; 5a4b2 (16:64b2)
+	dw HallofFameRoomScript0
+	dw HallofFameRoomScript1
+	dw HallofFameRoomScript2
+	dw HallofFameRoomScript3
 
 HallofFameRoomScript3: ; 5a4ba (16:64ba)
 	db $c9
@@ -91200,7 +93267,7 @@ HallofFameRoomScript1: ; 5a52b (16:652b)
 	ld [W_HALLOFFAMEROOMCURSCRIPT], a
 	ret
 
-HallofFameRoomTexts: ; 5a56a (16:656a)
+HallofFameRoomTextPointers: ; 5a56a (16:656a)
 	dw HallofFameRoomText1
 
 HallofFameRoomText1: ; 5a56c (16:656c)
@@ -91282,7 +93349,7 @@ ViridianForestexitBlocks: ; 5c090 (17:4090)
 RedsHouse2F_h: ; 5c0a4 (17:40a4)
 	db $04 ; tileset
 	db $04,$04 ; dimensions
-	dw RedsHouse2FBlocks, RedsHouse2FTexts, RedsHouse2FScript
+	dw RedsHouse2FBlocks, RedsHouse2FTextPointers, RedsHouse2FScript
 	db 0 ; no connections
 	dw RedsHouse2FObject
 
@@ -91293,9 +93360,10 @@ RedsHouse2FScript: ; 5c0b0 (17:40b0)
 	jp CallFunctionInTable
 
 RedsHouse2FScriptPointers: ; 5c0bc (17:40bc)
-	dw RedsHouse2FScript1,RedsHouse2FScript2
+	dw RedsHouse2FScript0
+	dw RedsHouse2FScript1
 
-RedsHouse2FScript1: ; 5c0c0 (17:40c0)
+RedsHouse2FScript0: ; 5c0c0 (17:40c0)
 	xor a
 	ld [H_CURRENTPRESSEDBUTTONS],a
 	ld a,8
@@ -91304,10 +93372,10 @@ RedsHouse2FScript1: ; 5c0c0 (17:40c0)
 	ld [W_REDSHOUSE2CURSCRIPT],a
 	ret
 
-RedsHouse2FScript2: ; 5c0ce (17:40ce)
+RedsHouse2FScript1: ; 5c0ce (17:40ce)
 	ret
 
-RedsHouse2FTexts: ; 5c0cf (17:40cf)
+RedsHouse2FTextPointers: ; 5c0cf (17:40cf)
 	db "@"
 
 RedsHouse2FObject: ; 0x5c0d0 ?
@@ -91335,7 +93403,7 @@ Func_5c0dc: ; 5c0dc (17:40dc)
 MuseumF1_h: ; 0x5c0eb to 0x5c0f7 (12 bytes) (id=52)
 	db $0a ; tileset
 	db MUSEUM_1F_HEIGHT, MUSEUM_1F_WIDTH ; dimensions (y, x)
-	dw MuseumF1Blocks, MuseumF1Texts, MuseumF1Script ; blocks, texts, scripts
+	dw MuseumF1Blocks, MuseumF1TextPointers, MuseumF1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw MuseumF1Object ; objects
@@ -91345,12 +93413,13 @@ MuseumF1Script: ; 5c0f7 (17:40f7)
 	ld [$cf0c], a
 	xor a
 	ld [$cc3c], a
-	ld hl, MuseumF1Scripts
+	ld hl, MuseumF1ScriptPointers
 	ld a, [W_MUSEUMF1CURSCRIPT]
 	jp CallFunctionInTable
 
-MuseumF1Scripts: ; 5c109 (17:4109)
-	dw MuseumF1Script0, MuseumF1Script1
+MuseumF1ScriptPointers: ; 5c109 (17:4109)
+	dw MuseumF1Script0
+	dw MuseumF1Script1
 
 MuseumF1Script0: ; 5c10d (17:410d)
 	ld a, [$d361]
@@ -91372,8 +93441,12 @@ MuseumF1Script0: ; 5c10d (17:410d)
 MuseumF1Script1: ; 5c12a (17:412a)
 	ret
 
-MuseumF1Texts: ; 5c12b (17:412b)
-	dw MuseumF1Text1, MuseumF1Text2, MuseumF1Text3, MuseumF1Text4, MuseumF1Text5
+MuseumF1TextPointers: ; 5c12b (17:412b)
+	dw MuseumF1Text1
+	dw MuseumF1Text2
+	dw MuseumF1Text3
+	dw MuseumF1Text4
+	dw MuseumF1Text5
 
 MuseumF1Text1: ; 5c135 (17:4135)
 	db $8
@@ -91618,7 +93691,7 @@ MuseumF1Object: ; 0x5c2c1 (size=74)
 MuseumF2_h: ; 0x5c30b to 0x5c317 (12 bytes) (id=53)
 	db $0a ; tileset
 	db MUSEUM_2F_HEIGHT, MUSEUM_2F_WIDTH ; dimensions (y, x)
-	dw MuseumF2Blocks, MuseumF2Texts, MuseumF2Script ; blocks, texts, scripts
+	dw MuseumF2Blocks, MuseumF2TextPointers, MuseumF2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw MuseumF2Object ; objects
@@ -91626,8 +93699,14 @@ MuseumF2_h: ; 0x5c30b to 0x5c317 (12 bytes) (id=53)
 MuseumF2Script: ; 5c317 (17:4317)
 	jp EnableAutoTextBoxDrawing
 
-MuseumF2Texts: ; 5c31a (17:431a)
-	dw MuseumF2Text1, MuseumF2Text2, MuseumF2Text3, MuseumF2Text4, MuseumF2Text5, MuseumF2Text6, MuseumF2Text7
+MuseumF2TextPointers: ; 5c31a (17:431a)
+	dw MuseumF2Text1
+	dw MuseumF2Text2
+	dw MuseumF2Text3
+	dw MuseumF2Text4
+	dw MuseumF2Text5
+	dw MuseumF2Text6
+	dw MuseumF2Text7
 
 MuseumF2Text1: ; 5c328 (17:4328)
 	TX_FAR _MuseumF2Text1
@@ -91680,7 +93759,7 @@ MuseumF2Object: ; 0x5c34b (size=48)
 PewterGym_h: ; 0x5c37b to 0x5c387 (12 bytes) (id=54)
 	db $07 ; tileset
 	db PEWTER_GYM_HEIGHT, PEWTER_GYM_WIDTH ; dimensions (y, x)
-	dw PewterGymBlocks, PewterGymTexts, PewterGymScript ; blocks, texts, scripts
+	dw PewterGymBlocks, PewterGymTextPointers, PewterGymScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw PewterGymObject ; objects
@@ -91692,7 +93771,7 @@ PewterGymScript: ; 5c387 (17:4387)
 	call nz, PewterGymScript_Unknown5c3a4
 	call EnableAutoTextBoxDrawing
 	ld hl, PewterGymTrainerHeaders
-	ld de, Unknown_5c3ca ; $43ca
+	ld de, PewterGymScriptPointers
 	ld a, [W_PEWTERGYMCURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_PEWTERGYMCURSCRIPT], a
@@ -91716,8 +93795,13 @@ Func_5c3bf: ; 5c3bf (17:43bf)
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Unknown_5c3ca: ; 5c3ca (17:43ca)
-INCBIN "baserom.gbc",$5c3ca,$5c3d2 - $5c3ca
+PewterGymScriptPointers: ; 5c3ca (17:43ca)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
+	dw PewterGymScript3
+
+PewterGymScript3: ; 5c3d2 (17:43d2)
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
 	jp z, Func_5c3bf
@@ -91763,8 +93847,13 @@ Func_5c3df: ; 5c3df (17:43df)
 	set 2, [hl]
 	jp Func_5c3bf
 
-PewterGymTexts: ; 5c435 (17:4435)
-	dw PewterGymText1, PewterGymText2, PewterGymText3, PewterGymText4, PewterGymText5, PewterGymText6
+PewterGymTextPointers: ; 5c435 (17:4435)
+	dw PewterGymText1
+	dw PewterGymText2
+	dw PewterGymText3
+	dw PewterGymText4
+	dw PewterGymText5
+	dw PewterGymText6
 
 PewterGymTrainerHeaders: ; 5c441 (17:4441)
 PewterGymTrainerHeader0: ; 5c441 (17:4441)
